.rules-release-branch: &rules-release-branch
  rules:
    - if: '$CI_COMMIT_BRANCH =~ /^release\/[0-9.]+/'

### Template limiting job to version tags only
.rules-version-tag: &rules-version-tag
  rules:
    - if: '$CI_COMMIT_TAG =~ /[0-9.]+$/'

stages:
  - tag
  - release

finish_release:
  stage: release
  <<: *rules-release-branch
  when: manual
  script:
    - VERSION_NAME=`echo $CI_COMMIT_BRANCH | cut -d '/' -f 2`
    - git config --global user.email "dat.pham@synetech.cz"
    - git config --global user.name "Dat Pham"
    - originURL=`git remote get-url origin | tr -d '\n' | cut -d '@' -f 2`
    - 'curl --request POST --header "PRIVATE-TOKEN: glpat-msY2cBxsppQx2Tay63Mb" --data "version=$VERSION_NAME&branch=$CI_COMMIT_BRANCH" "https://gitlab.com/api/v4/projects/44140374/repository/changelog"'
    - git fetch
    - git checkout $CI_COMMIT_BRANCH
    - git tag $VERSION_NAME
    - git push "https://dat.pham2:glpat-msY2cBxsppQx2Tay63Mb@$originURL" $VERSION_NAME
    - git fetch --all --tags
    - git checkout main
    - git pull
    - git merge $VERSION_NAME --ff-only
    - git push "https://dat.pham2:glpat-msY2cBxsppQx2Tay63Mb@$originURL" main:main
    - git checkout dev
    - git pull
    - git merge $VERSION_NAME --no-ff
    - git push "https://dat.pham2:glpat-msY2cBxsppQx2Tay63Mb@$originURL" dev:dev

### Job triggered on version tag to prepare CHANGELOG using git-chglog tool
createReleaseNotes:
  stage: release
  <<: *rules-version-tag
  script:
    - 'curl --header "PRIVATE-TOKEN: glpat-msY2cBxsppQx2Tay63Mb" "https://gitlab.com/api/v4/projects/44140374/repository/changelog?trailer=ReleaseNotes&version=$CI_COMMIT_TAG" | cut -d ''"'' -f 4 >> release_notes.txt'
  artifacts:
    paths:
      - release_notes.txt
    expire_in: 1 week

### Job triggered on version tag to publish CHANGELOG to releases
publishReleaseNotes:
  stage: release
  <<: *rules-version-tag
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs:
    - job: createReleaseNotes
      artifacts: true
  before_script: [ ]
  script:
    - echo "Publishing release notes ..."
  release:
    tag_name: '$CI_COMMIT_TAG'
    description: '$(echo -e $(cat release_notes.txt))'